################################################
### chunk number 1: Create big R object eval=FALSE
################################################
dim <- 500
Robj <- rep( list( matrix(1, nrow = dim, ncol = dim) ), 5)


################################################
### chunk number 2: Send data using Rmpi eval=FALSE
################################################
library("Rmpi")
mpi.spawn.Rslaves(nslaves = 10)
t <- replicate(5, system.time(mpi.bcast.Robj2slave(obj = Robj)))
tint <- summary(t[3,])
mpi.close.Rslaves()


################################################
### chunk number 3: Send data using NWS eval=FALSE
################################################
library("nws")
system("cat $PBS_NODEFILE > cluster.txt")
mycluster <- scan(file = "cluster.txt", what = "character")
s <- sleigh(nodeList = mycluster[-1], 
	     launch = sshcmd, workerCount = 10)
slavefunc <- function(x){ 
     assign("Robj", x, envir = .GlobalEnv); return(NULL) 
}
t <- replicate(5, system.time( eachWorker(s, slavefunc, Robj) ))
tint <- summary(t[3,])
stopSleigh(s)


################################################
### chunk number 4: Load snow library eval=FALSE
################################################
library("snow")


################################################
### chunk number 5: Send data using snow with Rmpi eval=FALSE
################################################
c1 <- makeMPIcluster(10)
t <- replicate(5, system.time( clusterExport(c1, list("Robj")) ))
tint <- summary(t[3,])
stopCluster(c1)


################################################
### chunk number 6: Send data using snow with PVM eval=FALSE
################################################
c1 <- makePVMcluster(10)
t <- replicate(5, system.time( clusterExport(c1, list("Robj")) ))
tint <- summary(t[3,])
stopCluster(c1)


################################################
### chunk number 7: Send data using snow with NWS eval=FALSE
################################################
system("cat $PBS_NODEFILE > cluster.txt")
mycluster <- scan(file = "cluster.txt" ,what="character")
c1 <- makeNWScluster(mycluster[2:11])
t <- replicate(5, system.time( clusterExport(c1, list("Robj")) ))
tint <- summary(t[3,])
stopCluster(c1)


################################################
### chunk number 8: Send data using snow with SOCKET eval=FALSE
################################################
system("cat $PBS_NODEFILE > cluster.txt")
mycluster <- scan(file = "cluster.txt", what = "character")
c1 <- makeSOCKcluster(mycluster[2:11])
t <- replicate(5, system.time( clusterExport(c1, list("Robj")) ))
tint <- summary(t[3,])
stopCluster(c1)


################################################
### chunk number 9: Load snowfall library eval=FALSE
################################################
library("snowfall")


################################################
### chunk number 10: Send data using snowfall with MPI eval=FALSE
################################################
sfInit(parallel = TRUE, cpus = 10, type = "MPI")
t <- replicate( 5, system.time( sfExport( "Robj" ) ) ) 
tint <- summary(t[3,])
sfStop()


################################################
### chunk number 11: Send data using snowfall with PVM eval=FALSE
################################################
sfInit(parallel = TRUE, cpus = 10, type = "PVM")
t <- replicate( 5, system.time( sfExport( "Robj" ) ) ) 
tint <- summary(t[3,])
sfStop()


################################################
### chunk number 12: Send data using snowfall with NWS eval=FALSE
################################################
system("cat $PBS_NODEFILE > cluster.txt")
mycluster <- scan(file = "cluster.txt", what = "character")
sfInit(parallel = TRUE, cpus = 10, type = "NWS", 
	     socketHosts = mycluster[2:11])
t <- replicate( 5, system.time( sfExport( "Robj" ) ) ) 
tint <- summary(t[3,])
sfStop()


################################################
### chunk number 13: Send data using snowfall with SOCKET eval=FALSE
################################################
system("cat $PBS_NODEFILE > cluster.txt")
mycluster <- scan(file = "cluster.txt", what = "character")
sfInit(parallel = TRUE, cpus = 10, type = "SOCK", 
	     socketHosts = mycluster[2:11])
t <- replicate( 5, system.time( sfExport( "Robj" ) ) ) 
tint <- summary(t[3,])
sfStop()
